@REGRESSION

  # NOTE: Intermittent issue - checkout page takes longer than 10 secs to load causing tests to fail https://supergroupbt.atlassian.net/browse/B2C2-4481


Feature: Checkout sourcing logic

  @B2C2-125
  Scenario: Setup environment with CheckoutSourcingLogic
    Given I seed config using the file "CheckoutSourcingLogic"
    When I open the siteId "b2c2125"

  @B2C2-125
  Scenario Outline: <seedingFile> - Load checkout, check product line(s) display correct data and that Cost Based sourcing and Priority based sourcing rules apply where needed
    Given I seed using the file "<seedingFile>" and add custom quantity into my "basket" local storage with the array "<quantities>"
    When I open the page "/checkout"
    And I wait on element "CheckoutDelivery.homeDeliveryRadio"
    Then I expect that element "CheckoutSourcingLogic.splitDeliveryHeading" is <isSplit>
    And I expect that element "CheckoutSourcingLogic.splitDeliveryText1" is <isSplit>
    And I expect that element "CheckoutSourcingLogic.splitDeliveryText2" is <isSplit>
    And I scroll to element "Product 1 name"
    And I expect that element "CheckoutSourcingLogic.delivery1ofText" is <delivery1State>
    And I expect that element "CheckoutSourcingLogic.delivery2ofText" is <delivery2State>
    And I expect that element "CheckoutSourcingLogic.delivery3ofText" is <delivery3State>
    And I expect that element "CheckoutSourcingLogic.delivery4ofText" is <delivery4State>
    And I expect that element "UK delivery1" is <deliveryOptions1State>
    And I expect that element "UK delivery2" is <deliveryOptions2State>
    And I expect that element "UK delivery3" is <deliveryOptions3State>
    And I expect that element "UK delivery4" is <deliveryOptions4State>
    And I expect that element "Product 1 name" does appear exactly "<product1NameAppears>" times
    And I expect that element "uniqueSize1" does appear exactly "<product1NameAppears>" times
    And I expect that element "Product 1 colour" does appear exactly "<product1NameAppears>" times
    And I expect that element "Product 2 name" does <product2Flag> exactly "<product2NameAppears>" times
    And I expect that element "uniqueSize2" does <product2Flag> exactly "<product2NameAppears>" times
    And I expect that element "Product 2 colour" does <product2Flag> exactly "<product2NameAppears>" times
    And I expect that element "Product 3 name" does <product3Flag> exactly "<product3NameAppears>" times
    And I expect that element "uniqueSize3" does <product3Flag> exactly "<product3NameAppears>" times
    And I expect that element "Product 3 colour" does <product3Flag> exactly "<product3NameAppears>" times
    And I expect that element "£<product1Price>" does appear exactly "<product1PriceAppears>" times
    And I expect that element "£<product2Price>" does appear exactly "<product2PriceAppears>" times
    And I expect that element "£<product3Price>" does appear exactly "<product3PriceAppears>" times
    And I expect that element "£<subtotal1>" does appear exactly "<subtotal1Appears>" times
    And I expect that element "£<subtotal2>" does appear exactly "<subtotal2Appears>" times
    And I expect that element "£<subtotal3>" does appear exactly "<subtotal3Appears>" times
    And I expect that element "£<total>" does appear exactly "1" times
    And I expect that element "<imageSelector>" does <imageAppears> exactly "<numberOfImages>" times

    @SKIP_MOBILE
    Examples:
      | seedingFile                    | quantities | isSplit       | product1Price | product1PriceAppears | product1NameAppears | product2Flag | product2Price | product2PriceAppears | product2NameAppears | product3Flag | product3Price | product3PriceAppears | product3NameAppears | subtotal1 | subtotal1Appears | subtotal2 | subtotal2Appears | subtotal3 | subtotal3Appears | total  | numberOfImages | imageAppears | imageSelector                       | deliveryOptions1State | deliveryOptions2State | deliveryOptions3State | deliveryOptions4State | delivery1State | delivery2State | delivery3State | delivery4State |
      | CheckoutSourcingLogicScenario1 | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 2                |           | 0                |           | 0                | 203.93 | 1              | appear      | CheckoutSourcingLogic.productImages | not displayed         | displayed             | not displayed         | not displayed         | not displayed  | not displayed  | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario2 | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 2                |           | 0                |           | 0                | 203.93 | 1              | appear      | CheckoutSourcingLogic.productImages | displayed             | not displayed         | not displayed         | not displayed         | not displayed  | not displayed  | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario4 | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 2                |           | 0                |           | 0                | 203.93 | 1              | appear      | CheckoutSourcingLogic.productImages | not displayed         | not displayed         | not displayed         | displayed             | not displayed  | not displayed  | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario8 | 3,1        | not displayed | 99.99         | 1                    | 1                   | appear       | 59.99         | 2                    | 1                   | not appear   |               | 0                    | 0                   | 299.97    | 1                | 359.96    | 1                |           | 0                | 363.91 | 2              | appear      | CheckoutSourcingLogic.productImages | not displayed         | displayed             | not displayed         | not displayed         | not displayed  | not displayed  | not displayed  | not displayed  |

    @SKIP_DESKTOP @SKIP_TABLET
    Examples:
      | seedingFile                    | quantities | isSplit       | product1Price | product1PriceAppears | product1NameAppears | product2Flag | product2Price | product2PriceAppears | product2NameAppears | product3Flag | product3Price | product3PriceAppears | product3NameAppears | subtotal1 | subtotal1Appears | subtotal2 | subtotal2Appears | subtotal3 | subtotal3Appears | total  | numberOfImages | imageAppears | imageSelector  | deliveryOptions1State | deliveryOptions2State | deliveryOptions3State | deliveryOptions4State | delivery1State | delivery2State | delivery3State | delivery4State |
      | CheckoutSourcingLogicScenario1 | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 2                |           | 0                |           | 0                | 203.93 | 0              | not appear   | not applicable | not displayed         | displayed             | not displayed         | not displayed         | not displayed  | not displayed  | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario2 | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 2                |           | 0                |           | 0                | 203.93 | 0              | not appear   | not applicable | displayed             | not displayed         | not displayed         | not displayed         | not displayed  | not displayed  | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario4 | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 2                |           | 0                |           | 0                | 203.93 | 0              | not appear   | not applicable | not displayed         | not displayed         | not displayed         | displayed             | not displayed  | not displayed  | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario8 | 3,1        | not displayed | 99.99         | 1                    | 1                   | appear       | 59.99         | 2                    | 1                   | not appear   |               | 0                    | 0                   | 299.97    | 1                | 359.96    | 1                |           | 0                | 363.91 | 0              | not appear   | not applicable | not displayed         | displayed             | not displayed         | not displayed         | not displayed  | not displayed  | not displayed  | not displayed  |

#    Below tests are skipped due to an issue with subtotals in the checkout: https://supergroupbt.atlassian.net/browse/B2C2-3861
    @DEFECT
    Examples:
      | seedingFile                     | quantities | isSplit       | product1Price | product1PriceAppears | product1NameAppears | product2Flag | product2Price | product2PriceAppears | product2NameAppears | product3Flag | product3Price | product3PriceAppears | product3NameAppears | subtotal1 | subtotal1Appears | subtotal2 | subtotal2Appears | subtotal3 | subtotal3Appears | total  | numberOfImages | imageAppears | imageSelector                       | deliveryOptions1State | deliveryOptions2State | deliveryOptions3State | deliveryOptions4State | delivery1State | delivery2State | delivery3State | delivery4State |
      | CheckoutSourcingLogicScenario3  | 2          | not displayed | 99.99         | 4                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 1                |           | 0                |           | 0                | 203.93 | 2              | appear       | CheckoutSourcingLogic.productImages | displayed             | displayed             | not displayed         | not displayed         | displayed      | displayed      | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario5  | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 1                |           | 0                |           | 0                | 203.93 | 2              | appear       | CheckoutSourcingLogic.productImages | displayed             | displayed             | not displayed         | displayed             | displayed      | displayed      | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario6  | 2,2        | displayed     | 99.99         | 1                    | 1                   | appear       | 59.99         | 4                    | 2                   | not appear   |               | 0                    | 0                   | 199.98    | 1                | 319.96    | 1                |           | 0                | 323.46 | 3              | appear       | CheckoutSourcingLogic.productImages | displayed             | displayed             | not displayed         | not displayed         | displayed      | displayed      | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario7  | 2,2        | displayed     | 99.99         | 1                    | 1                   | appear       | 59.99         | 4                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 1                | 319.96    | 1                |           | 0                | 323.46 | 3              | appear       | CheckoutSourcingLogic.productImages | displayed             | not displayed         | displayed             | displayed             | displayed      | displayed      | displayed      | not displayed  |
      | CheckoutSourcingLogicScenario9  | 4,4        | displayed     | 99.99         | 5                    | 3                   | appear       | 59.99         | 5                    | 3                   | not appear   |               | 0                    | 0                   | 119.98    | 1                | 199.98    | 1                | 639.92    | 1                | 643.42 | 6              | appear       | CheckoutSourcingLogic.productImages | displayed             | displayed             | displayed             | displayed             | displayed      | displayed      | displayed      | displayed      |
      | CheckoutSourcingLogicScenario10 | 3,2,1      | displayed     | 99.99         | 6                    | 3                   | appear       | 59.99         | 1                    | 1                   | appear       | 79.99         | 2                    | 1                   | 119.98    | 1                | 499.94    | 1                |           | 0                | 503.44 | 5              | appear       | CheckoutSourcingLogic.productImages | not displayed         | displayed             | displayed             | displayed             | displayed      | displayed      | displayed      | not displayed  |

    #    Below tests are skipped due to an issue with subtotals in the checkout: https://supergroupbt.atlassian.net/browse/B2C2-3861
    @DEFECT @SKIP_DESKTOP @SKIP_TABLET
    Examples:
      | seedingFile                     | quantities | isSplit       | product1Price | product1PriceAppears | product1NameAppears | product2Flag | product2Price | product2PriceAppears | product2NameAppears | product3Flag | product3Price | product3PriceAppears | product3NameAppears | subtotal1 | subtotal1Appears | subtotal2 | subtotal2Appears | subtotal3 | subtotal3Appears | total  | numberOfImages | imageAppears | imageSelector  | deliveryOptions1State | deliveryOptions2State | deliveryOptions3State | deliveryOptions4State | delivery1State | delivery2State | delivery3State | delivery4State |
      | CheckoutSourcingLogicScenario3  | 2          | not displayed | 99.99         | 4                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 1                |           | 0                |           | 0                | 203.93 | 0              | not appear   | not applicable | displayed             | displayed             | not displayed         | not displayed         | displayed      | displayed      | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario5  | 2          | not displayed | 99.99         | 1                    | 1                   | not appear   |               | 0                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 1                |           | 0                |           | 0                | 203.93 | 0              | not appear   | not applicable | displayed             | displayed             | not displayed         | displayed             | displayed      | displayed      | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario6  | 2,2        | displayed     | 99.99         | 1                    | 1                   | appear       | 59.99         | 4                    | 2                   | not appear   |               | 0                    | 0                   | 199.98    | 1                | 319.96    | 1                |           | 0                | 323.46 | 0              | not appear   | not applicable | displayed             | displayed             | not displayed         | not displayed         | displayed      | displayed      | not displayed  | not displayed  |
      | CheckoutSourcingLogicScenario7  | 2,2        | displayed     | 99.99         | 1                    | 1                   | appear       | 59.99         | 4                    | 0                   | not appear   |               | 0                    | 0                   | 199.98    | 1                | 319.96    | 1                |           | 0                | 323.46 | 0              | not appear   | not applicable | displayed             | not displayed         | displayed             | displayed             | displayed      | displayed      | displayed      | not displayed  |
      | CheckoutSourcingLogicScenario9  | 4,4        | displayed     | 99.99         | 5                    | 3                   | appear       | 59.99         | 5                    | 3                   | not appear   |               | 0                    | 0                   | 119.98    | 1                | 199.98    | 1                | 639.92    | 1                | 643.42 | 0              | not appear   | not applicable | displayed             | displayed             | displayed             | displayed             | displayed      | displayed      | displayed      | displayed      |
      | CheckoutSourcingLogicScenario10 | 3,2,1      | displayed     | 99.99         | 6                    | 3                   | appear       | 59.99         | 1                    | 1                   | appear       | 79.99         | 2                    | 1                   | 119.98    | 1                | 499.94    | 1                |           | 0                | 503.44 | 0              | not appear   | not applicable | not displayed         | displayed             | displayed             | displayed             | displayed      | displayed      | displayed      | not displayed  |

  @B2C2-3861
  Scenario: Correct total and subtotal prices are shown for a product with split deliveries
    Given I open the page "/"
    And I seed config using the file "CheckoutSplitDeliveryPrice"
    And I open the siteId "b2c23861"
    And I seed using the file "CheckoutSplitDeliveryPrice" and add the items into my "basket" local storage
    When I open the page "/checkout"
    Then I expect that element "£99.99" does appear exactly "4" times
    And I expect that element "£199.98" does appear exactly "1" times